unit CustomIDE;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, MyObjectInspector, InspectedForm;

type
  TMyIDE = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Inspector1: TMenuItem;
    Open1: TMenuItem;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    mmScript: TMemo;
    GroupBox3: TGroupBox;
    btnShow: TButton;
    mmHowto: TMemo;
    btnClose: TButton;
    procedure Exit1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Show(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
  private
    { Private declarations }
    fMyObjectInspector: TfrmMyObjectInspector;
    fInspectedForm: TfrmInspectedForm;
    procedure OpenObjectInspector;
    procedure DefinitionChange(Sender: TObject; AObjectName, AEventName, MethodDeclaration: string; ACompleteDefinition: TStringList);
  end;

var
  MyIDE: TMyIDE;

implementation

{$R *.dfm}

procedure TMyIDE.Show(Sender: TObject);
begin
  fInspectedForm.Show;
end;

procedure TMyIDE.btnCloseClick(Sender: TObject);
begin
  fInspectedForm.Close;
end;

procedure TMyIDE.DefinitionChange(Sender: TObject; AObjectName, AEventName,
  MethodDeclaration: string; ACompleteDefinition: TStringList);
var
  I: Integer;
begin
  mmScript.Lines.Add('//Object Name: '+AObjectName+' Method Declaration: '+MethodDeclaration);
  for I := 0 to ACompleteDefinition.Count - 1 do
    mmScript.Lines.Add(ACompleteDefinition.Strings[I]);
end;

procedure TMyIDE.OpenObjectInspector;
begin
  if not Assigned(fMyObjectInspector) then
  begin
    fMyObjectInspector:= TfrmMyObjectInspector.Create(nil);
    fMyObjectInspector.Left:= Self.Left - fMyObjectInspector.Width;
    fMyObjectInspector.Top:= Self.Top;
    fMyObjectInspector.MsiInspectorComboBox1.InspectedForm:= fInspectedForm;
    fMyObjectInspector.MSIInspector1.OnDefinitionChange:= DefinitionChange;
  end;
  fMyObjectInspector.Show;
  fMyObjectInspector.SetFocus;
end;

procedure TMyIDE.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMyIDE.FormCreate(Sender: TObject);
begin
  fInspectedForm:= TfrmInspectedForm.Create(nil);
end;

procedure TMyIDE.FormDestroy(Sender: TObject);
begin
  fInspectedForm.Free;
end;

procedure TMyIDE.FormResize(Sender: TObject);
begin
  openObjectInspector;
end;

procedure TMyIDE.Open1Click(Sender: TObject);
begin
  openObjectInspector;
end;

end.
